################
### MONITORS ###
################
monitor=,preffered,auto,1

###################
### MY PROGRAMS ###
###################
$nvim = alacritty -e ~/linuxbox/start_nvim.sh
$terminal = alacritty
$browser = brave --new-window --hide-crash-restore-bubble

#################
### AUTOSTART ###
#################
exec = gsettings set org.gnome.desktop.interface gtk-theme "Adwaita-dark"   # for GTK3 apps
exec = gsettings set org.gnome.desktop.interface color-scheme "prefer-dark"   # for GTK4 apps

exec-once = /usr/lib/polkit-gnome/polkit-gnome-authentication-agent-1
exec-once = udiskie 
exec-once = waybar 
exec-once = systemctl --user start sunshine

#############################
### ENVIRONMENT VARIABLES ###
#############################
env = XCURSOR_SIZE,24
env = HYPRCURSOR_SIZE,24
env = QT_QPA_PLATFORM,wayland
env = QT_QPA_PLATFORMTHEME,qt5ct   # for Qt apps

#####################
### LOOK AND FEEL ###
#####################
general {
    gaps_in = 5
    gaps_out = 5 
    border_size = 2
    col.inactive_border = rgba(333333ff)
    col.active_border = rgba(555555ff)
    resize_on_border = false
    allow_tearing = false
    layout = dwindle
}

decoration {
    rounding = 5
    active_opacity = 1.0
    inactive_opacity = 1.0
    dim_special = 0.7
    dim_around = 0.7
    
    shadow {
        enabled = true
        range = 4
        render_power = 3
        color = rgba(1a1a1aee)
    }

    blur {
        enabled = false
        size = 3
        passes = 1
        special = true
        vibrancy = 0.1696
        popups = false
    }
}

animations {
    enabled = yes, please :)

    bezier = easeOutQuint,0.23,1,0.32,1
    bezier = easeInOutCubic,0.65,0.05,0.36,1
    bezier = linear,0,0,1,1
    bezier = almostLinear,0.5,0.5,0.75,1.0
    bezier = quick,0.15,0,0.1,1

    animation = global, 1, 10, default
    animation = border, 1, 5.39, easeOutQuint
    animation = windows, 1, 4.79, easeOutQuint
    animation = windowsIn, 1, 4.1, easeOutQuint, popin 87%
    animation = windowsOut, 1, 1.49, linear, popin 87%
    animation = fadeIn, 1, 1.73, almostLinear
    animation = fadeOut, 1, 1.46, almostLinear
    animation = fade, 1, 3.03, quick
    animation = layers, 1, 3.81, easeOutQuint
    animation = layersIn, 1, 4, easeOutQuint, fade
    animation = layersOut, 1, 1.5, linear, fade
    animation = fadeLayersIn, 1, 1.79, almostLinear
    animation = fadeLayersOut, 1, 1.39, almostLinear
    animation = workspaces, 1, 1.94, almostLinear, fade
    animation = workspacesIn, 1, 1.21, almostLinear, fade
    animation = workspacesOut, 1, 1.94, almostLinear, fade
}

dwindle {
    pseudotile = true # Master switch for pseudotiling. Enabling is bound to mainMod + P in the keybinds section below
    preserve_split = true # You probably want this
    permanent_direction_override = true
}

master {
    new_status = slave
    mfact = 0.5
}

misc {
    force_default_wallpaper = -1 # Set to 0 or 1 to disable the anime mascot wallpapers
    disable_hyprland_logo = true # If true disables the random hyprland logo / anime girl background. :(
    disable_splash_rendering = true
    mouse_move_enables_dpms = true
    vfr = true
    vrr = 0
    animate_manual_resizes = true
    mouse_move_focuses_monitor = false
    enable_swallow = false
    swallow_regex = ^(wezterm)$
}

#############
### INPUT ###
#############
input {
    kb_layout = se 
    kb_variant =
    kb_model =
    kb_rules =
    kb_options = ctrl:nocaps, fkeys:basic_13-24
    follow_mouse = 1
    sensitivity = 0.0 # -1.0 - 1.0, 0 means no modification.
    accel_profile = flat

    touchpad {
        natural_scroll = false
    }
}

cursor {
    hide_on_key_press = true
}

gestures {
    workspace_swipe = false
}

device {
    name = elecom-trackball-mouse-deft-pro-trackball-1
    sensitivity = 0.7
    accel_profile = flat
}

device {
    name = mouse-passthrough
    sensitivity = 1.0 
    accel_profile = adaptive
}

###################
### KEYBINDINGS ###
###################
$mainMod = SHIFT ALT 

bind = $mainMod, X, fullscreen
bind = $mainMod, C, killactive,
bind = $mainMod, Z, togglefloating,
bind = $mainMod, H, layoutmsg, preselect l
bind = $mainMod, L, layoutmsg, preselect r
bind = $mainMod, J, layoutmsg, preselect d
bind = $mainMod, K, layoutmsg, preselect u
bind = $mainMod, M, exec, com.moonlight_stream.Moonlight
bind = $mainMod, F, exec, walker --modules applications
bind = SUPER, L, exec, python ~/linuxbox/black.py
bind = $mainMod CTRL, W, exec, $browser
bind = $mainMod , N, exec, $nvim
bind = ALT, Tab, workspace, e+1
bind = ALT SHIFT, Tab, workspace, emptyn
bind = , PRINT, exec, hyprshot -m region 

# Set monitor resolution (fix for sunshine streaming to laptop)
bind = $mainMod, R, exec, hyprctl keyword monitor ",1920x1200,auto,1"
bind = $mainMod CTRL, R, exec, hyprctl keyword monitor ",preffered,auto,1"

# Special workspace (scratchpad)
bind = $mainMod, S, togglespecialworkspace, scratchpad
bind = $mainMod, B, togglespecialworkspace, btop
bind = $mainMod, V, togglespecialworkspace, mixer

# Move focus with mainMod + arrow keys
bind = $mainMod, left, movefocus, l
bind = $mainMod, right, movefocus, r
bind = $mainMod, up, movefocus, u
bind = $mainMod, down, movefocus, d

# Switch workspaces with mainMod + [0-9]
bind = $mainMod, 1, workspace, 1
bind = $mainMod, 2, workspace, 2
bind = $mainMod, 3, workspace, 3
bind = $mainMod, 4, workspace, 4
bind = $mainMod, 5, workspace, 5
bind = $mainMod, 6, workspace, 6
bind = $mainMod, 7, workspace, 7
bind = $mainMod, 8, workspace, 8
bind = $mainMod, 9, workspace, 9
bind = $mainMod, 0, workspace, 10

# Move active window to a workspace with mainMod + SHIFT + [0-9]
bind = $mainMod CTRL, 1, movetoworkspace, 1 
bind = $mainMod CTRL, 2, movetoworkspace, 2
bind = $mainMod CTRL, 3, movetoworkspace, 3
bind = $mainMod CTRL, 4, movetoworkspace, 4
bind = $mainMod CTRL, 5, movetoworkspace, 5
bind = $mainMod CTRL, 6, movetoworkspace, 6
bind = $mainMod CTRL, 7, movetoworkspace, 7
bind = $mainMod CTRL, 8, movetoworkspace, 8
bind = $mainMod CTRL, 9, movetoworkspace, 9
bind = $mainMod CTRL, 0, movetoworkspace, 10

# Move/resize windows with mainMod + LMB/RMB and dragging
bindm = $mainMod, mouse:272, movewindow
bindm = $mainMod, mouse:273, resizewindow

# Laptop multimedia keys for volume and LCD brightness
bindel = ,XF86AudioRaiseVolume, exec, wpctl set-volume @DEFAULT_AUDIO_SINK@ 5%+
bindel = ,XF86AudioLowerVolume, exec, wpctl set-volume @DEFAULT_AUDIO_SINK@ 5%-
bindel = ,XF86AudioMute, exec, wpctl set-mute @DEFAULT_AUDIO_SINK@ toggle
bindel = ,XF86AudioMicMute, exec, wpctl set-mute @DEFAULT_AUDIO_SOURCE@ toggle

##############################
### WINDOWS AND WORKSPACES ###
##############################
# "Smart gaps" / "No gaps when only"
workspace = w[tv1], gapsout:0, gapsin:0
workspace = f[1], gapsout:0, gapsin:0
windowrulev2 = bordersize 0, floating:0, onworkspace:w[tv1]
windowrulev2 = rounding 0, floating:0, onworkspace:w[tv1]
windowrulev2 = bordersize 0, floating:0, onworkspace:f[1]
windowrulev2 = rounding 0, floating:0, onworkspace:f[1]

# Terminal scratchpad
windowrulev2 = float, onworkspace:special:scratchpad
windowrulev2 = size 80% 80%, onworkspace:special:scratchpad
workspace = special:scratchpad, on-created-empty:$terminal

# Web scratchpad
windowrulev2 = float, onworkspace:special:web
windowrulev2 = size 80% 80%, initialTitle:^(.*Brave.*)$
windowrulev2 = center, initialTitle:^(.*Brave.*)$
workspace = special:web, on-created-empty:$browser
windowrulev2 = size 450 253, initialTitle:^(Picture in picture)$
windowrulev2 = opacity 1.0 0.7, initialTitle:^(Picture in picture)$
windowrulev2 = float, initialTitle:^(Picture in picture)$
windowrulev2 = move 100%-w-20 60, initialTitle:^(Picture in picture)$
windowrulev2 = workspace e+0, initialTitle:^(Picture in picture)$

# Btop
windowrulev2 = float, onworkspace:special:btop
windowrulev2 = size 80% 80%, onworkspace:special:btop
workspace = special:btop, on-created-empty:$terminal -e btop

# Ranger
windowrulev2 = float, onworkspace:special:ranger
windowrulev2 = size 80% 80%, onworkspace:special:ranger
workspace = special:ranger, on-created-empty:$terminal -e ranger

# NMtui
windowrulev2 = float, onworkspace:special:nm
windowrulev2 = size 80% 80%, onworkspace:special:nm
workspace = special:nm, on-created-empty:nm-connection-editor

# Timer
windowrulev2 = float, onworkspace:special:timer
windowrulev2 = size 800 270, onworkspace:special:timer
workspace = special:timer, on-created-empty:io.github.efogdev.mpris-timer

# Discord
windowrulev2 = size 450 253, initialTitle:^(Discord Popout)$
windowrulev2 = float, onworkspace:special:discord
windowrulev2 = float, initialTitle:^(.*Discord.*)$
windowrulev2 = size 80% 80%, initialTitle:^(.*Discord.*)$
workspace = special:discord, on-created-empty:flatpak run com.discordapp.Discord 
windowrulev2 = workspace special:discord, initialTitle:^(.*Discord.*)$
windowrulev2 = opacity 1.0 0.9, initialTitle:^(Discord Popout)$
windowrulev2 = float, initialTitle:^(Discord Popout)$
windowrulev2 = move 100%-w-20 60, initialTitle:^(Discord Popout)$
windowrulev2 = workspace e+0, initialTitle:^(Discord Popout)$

# Pipewire
windowrulev2 = float, title:^(volume control)$
windowrulev2 = dimaround, title:^(Volume Control)$
windowrulev2 = float, title:^(Helvum - Pipewire Patchbay)$
windowrulev2 = dimaround, title:^(Helvum - Pipewire Patchbay)$
windowrulev2 = float, onworkspace:special:mixer
windowrulev2 = size 30% 50%, onworkspace:special:mixer
workspace = special:mixer, on-created-empty:pavucontrol

# # Moonlight
# # windowrulev2 = workspace emptyn, title:^(.*- Moonlight.*)$
# windowrulev2 = float, initialTitle:^(Moonlight)$
# windowrulev2 = size 80% 80%, initialTitle:^(Moonlight)$
# windowrulev2 = center, initialTitle:^(Moonlight)$ 
# windowrulev2 = dimaround, initialTitle:^(Moonlight)$ 
#
# # KiCad
# windowrulev2 = workspace emptyn, initialTitle:^(.*KiCad.*)$
# windowrulev2 = workspace emptyn, initialTitle:^(.*PCB Editor.*)$
# windowrulev2 = workspace emptyn, initialTitle:^(.*Schematic Editor.*)$
# windowrulev2 = float, initialTitle:^(3D Viewer)$
# windowrulev2 = dimaround, initialTitle:^(3D Viewer)$
# windowrulev2 = size 80% 80%, $initialTitle:^(3D Viewer)$
#
# # Gimp
# windowrulev2 = workspace emptyn, initialTitle:^(.*GNU Image Manipulation Program.*)$
#
# # prusaSlicer
# windowrulev2 = workspace emptyn, initialTitle:^(.*PrusaSlicer.*)$
#
# # FreeCad
# windowrulev2 = workspace emptyn, initialTitle:^(FreeCAD.*)$

# screensaver workaround
windowrulev2 = fullscreen, title:^(BlackScreenApp)$

# Ignore maximize requests from apps. You'll probably like this.
windowrulev2 = suppressevent maximize, class:.*

# Fix some dragging issues with XWayland
windowrulev2 = nofocus,class:^$,title:^$,xwayland:1,floating:1,fullscreen:0,pinned:0

###############################
### COMPUTER SPECIFIC EXTRA ###
###############################
source=~/.config/hypr/hyprland_extra.conf
